<!-- This code has been written by Jasper Geelen (1328344) -->
<template>
  <div ref="div">
    <canvas ref="canvas" :width="width" :height="height" id="graph" />
  </div>
</template>

<script>
import * as d3 from "d3";
import lasso from "@/util/lasso";

export default {
  props: {
    width: {
      type: Number,
      required: true
    },
    height: {
      type: Number,
      required: true
    },
    data: Object,
    dark: Boolean,
    selectedNodes: Array,
    degree: Number
  },

  //All of the variables
  data() {
    return {
      canvas: null,
      context: null,
      selection: null,
      simulation: null,
      vEdges: null,
      transform: d3.zoomIdentity,
      color: d3.scaleOrdinal(d3.schemeCategory10),
      immutableNodeLinkedEdges: [],
      nodeLinkedEdges: {},
      maxDegree: 10,
      selectedPoints: [],
      hoverNode: null,
      mouseMovingFrequency: 0,
      lassoInstance: null,
      circleRadius: 3000
    };
  },

  watch: {
    dark: function() {
      this.tick();
    },
    width: function() {
      this.tick();
    },
    height: function() {
      this.tick();
    },
    data: function() {
      this.tick();
    },
    selectedNodes: function() {
      this.tick();
    },
    degree: function() {
      this.tick();
    }
  },

  computed: {
    nodes() {
      return this.data.graph ? this.data.graph.nodes : [];
    },
    links() {
      return this.data.graph ? this.data.graph.links : [];
    },
    lineWidth() {
      if (this.links.length < 10000) {
        return 2;
      } else if (this.links.length > 10000 && this.links.length < 50000) {
        return 1;
      } else {
        return 1;
      }
    },
    radius() {
      if (this.links.length < 10000) {
        return 5;
      } else {
        return 3;
      }
    }
  },

  methods: {
    //This method changes the nodeLinkedEdges variable dependant on the "degree" variable
    updateVisibility() {
      console.log("hello");
      const shouldBeVisibleNodes = this.immutableNodeLinkedEdges
        .map((n, i) => {
          if (n.length >= this.degree) {
            return i;
          }
        })
        .filter(x => x);

      this.nodeLinkedEdges = Array(this.immutableNodeLinkedEdges.length).fill(
        Array(0)
      );

      shouldBeVisibleNodes.forEach(n => {
        this.nodeLinkedEdges[n] = this.immutableNodeLinkedEdges[n];
      });
    },
    //This is the function that draws the nodes and lines constantly
    tick() {
      const {
        context,
        canvas,
        transform,
        lineWidth,
        vEdges,
        nodes,
        radius,
        color,
        hoverNode
      } = this;

      context.save();

      this.updateVisibility();
      this.setVisibleEdges();

      // clear canvas
      context.clearRect(0, 0, canvas.width, canvas.height);
      context.translate(transform.x, transform.y);
      context.scale(transform.k, transform.k);

      // draw white links
      // TODO: fix drawing of edges
      context.strokeStyle = this.dark ? "white" : "grey";
      context.lineWidth = lineWidth;
      context.beginPath();
      if (vEdges) {
        vEdges.forEach(function(d) {
          context.moveTo(d.source.x, d.source.y);
          context.lineTo(d.target.x, d.target.y);
        });
      }
      context.stroke();

      // draw nodes
      nodes.forEach(d => {
        if (this.selectedNodes.includes(d.id) || hoverNode == d) {
          context.fillStyle = "red";
        } else {
          context.fillStyle = color(d.group);
        }
        context.beginPath();
        context.moveTo(d.x, d.y);
        context.arc(d.x, d.y, radius, 0, 2 * Math.PI);
        context.fill();
      });

      //Check if you have to display tags
      if (hoverNode != null) {
        context.beginPath();
        let rectHeight = 10;
        let rectWidth = hoverNode.id.length * 3;
        context.fillStyle = this.dark ? "white" : "black";
        context.rect(
          hoverNode.x - rectWidth / 2,
          hoverNode.y - 20,
          rectWidth,
          rectHeight
        );
        context.fill();
        context.beginPath();
        context.font = "5px Georgia";
        context.textAlign = "center";
        context.textBaseline = "middle";

        context.fillStyle = this.dark ? "black" : "white";
        context.fillText(
          hoverNode.id.replace(/_/g, " "),
          hoverNode.x,
          hoverNode.y - 20 + rectHeight / 2
        );
      }

      context.restore();
    },
    //function for zooming
    zoomed() {
      this.transform = d3.event.transform;
      this.tick();
    },
    //functions for dragging nodes around
    dragsubject() {
      const { transform, nodes, radius } = this;

      var i,
        x = transform.invertX(d3.event.x),
        y = transform.invertY(d3.event.y),
        dx,
        dy;
      for (i = nodes.length - 1; i >= 0; --i) {
        let node = nodes[i];
        dx = x - node.x;
        dy = y - node.y;

        if (dx * dx + dy * dy < radius * radius) {
          node.x = transform.applyX(node.x);
          node.y = transform.applyY(node.y);

          return node;
        }
      }
    },
    dragstarted() {
      const { simulation, transform } = this;
      if (!d3.event.active) simulation.alphaTarget(0.3).restart();
      d3.event.subject.fx = transform.invertX(d3.event.x);
      d3.event.subject.fy = transform.invertY(d3.event.y);
    },
    dragged() {
      const { transform } = this;

      d3.event.subject.fx = transform.invertX(d3.event.x);
      d3.event.subject.fy = transform.invertY(d3.event.y);
    },
    dragended() {
      const { simulation } = this;

      if (!d3.event.active) simulation.alphaTarget(0);
      d3.event.subject.fx = null;
      d3.event.subject.fy = null;
    },

    mouseMoved() {
      this.mouseMovingFrequency++;
      if (this.mouseMovingFrequency % 10 == 0) {
        let mouseX = this.transform.invertX(d3.event.layerX);
        let mouseY = this.transform.invertY(d3.event.layerY);
        this.hoverNode = null;
        this.nodes.forEach(d => {
          if (
            mouseX >= d.x - this.radius &&
            mouseX <= d.x + this.radius &&
            mouseY >= d.y - this.radius &&
            mouseY <= d.y + this.radius
          ) {
            this.hoverNode = d;
          }
        });
        this.tick();
      }
    },
    //Decide which edges have to be drawn
    setVisibleEdges() {
      const vNodeEdges = this.nodeLinkedEdges
        .map((n, i) => {
          if (n.length > 0) return { index: i, nodes: n };
        })
        .filter(x => x);
      this.vEdges = this.links.filter(link =>
        vNodeEdges.map(n => n.index).includes(link.source.index)
      );
    },
    //functions for lasso
    handleLassoStart() {
      this.tick();
    },

    handleLassoEnd(lassoPolygon) {
      const { transform } = this;
      lassoPolygon.forEach(function(item) {
        item[0] = transform.invertX(item[0]);
        item[1] = transform.invertY(item[1]);
      });
      this.$store.commit(
        "setSelectedNodes",
        this.nodes
          .filter(function(d) {
            return d3.polygonContains(lassoPolygon, [d.x, d.y]);
          })
          .map(obj => {
            return obj.id;
          })
      );
      this.tick();
    },

    //make sure the slider has the right max
    updateMaxDegree() {
      this.$emit("set-degree", this.maxDegree);
    }
  },

  async mounted() {
    this.circleRadius = Math.floor((this.nodes.length * 85) / (2 * Math.PI));
    this.canvas = this.$refs["canvas"];
    d3.select(this.canvas).on("click", () => {
      let mouseX = this.transform.invertX(d3.event.layerX);
      let mouseY = this.transform.invertY(d3.event.layerY);
        this.nodes.forEach(d => {
          if (
            mouseX >= d.x - this.radius &&
            mouseX <= d.x + this.radius &&
            mouseY >= d.y - this.radius &&
            mouseY <= d.y + this.radius
          ) {
            this.$store.commit("addSelectedNode", d.id);
          }
        });
    });
    this.context = this.canvas.getContext("2d");
    //assign the forces
    this.simulation = d3
      .forceSimulation()
      .force(
        "link",
        d3
          .forceLink()
          .strength(0)
          .id(d => d.id)
      )
      .force("r", d3.forceRadial(() => this.circleRadius))
      .force("source", d3.forceX().strength(0.02))
      .force("target", d3.forceY().strength(0.02));
    this.selection = d3
      .select(this.canvas)
      .on("mousemove", this.mouseMoved)
      .call(
        d3
          .drag()
          .subject(this.dragsubject)
          .on("start", this.dragstarted)
          .on("drag", this.dragged)
          .on("end", this.dragended)
      )
      .call(
        d3
          .zoom()
          .scaleExtent([1 / 40, 8])
          .on("zoom", this.zoomed)
          .on("start", () => {
            this.vEdges = [];
          })
          .on("end", () => {
            this.tick();
          })
      );
    this.lassoInstance = await lasso("#0bb", false);
    this.lassoInstance
      .on("start", this.handleLassoStart)
      .on("end", this.handleLassoEnd);

    // create key listeners for selection option
    let scope = this;
    window.addEventListener("keydown", e => {
      if (e.keyCode == 16) {
        try {
          d3.select(scope.$refs["div"])
            .append("svg")
            .style("position", "absolute")
            .style("top", 0)
            .style("left", 0)
            .attr("width", scope.canvas.width) // change to super
            .attr("height", scope.canvas.height);
          d3.select(scope.$refs["div"])
            .select("svg")
            .call(scope.lassoInstance);
        } catch (exception) {
          // wait until element is loaded
        }
      }
    });

    window.addEventListener("keyup", e => {
      if (e.keyCode == 16) {
        d3.select(scope.$refs["div"])
          .selectAll("svg")
          .remove();
      }
    });

    // add event listener
    this.simulation.nodes(this.nodes).on("tick", this.tick);

    // assign force to simulation
    this.simulation.force("link").links(this.links);
    this.simulation.alpha(1).restart();

    //make dictionary for all edges
    this.nodeLinkedEdges = this.data.matrix.edges.map(i => {
      return i
        .map((j, index) => {
          if (j > 0) {
            return index;
          }
        })
        .filter(i => i);
    });

    //calculate the maximum degree of a node
    var i;
    for (i = 0; i < this.nodeLinkedEdges.length; i++) {
      if (this.nodeLinkedEdges[i].length > this.maxDegree) {
        this.maxDegree = this.nodeLinkedEdges[i].length;
      }
    }
    this.updateMaxDegree(this.maxDegree);

    this.immutableNodeLinkedEdges = [...this.nodeLinkedEdges];

    setTimeout(() => {
      this.setVisibleEdges();
    }, 1000);
    this.updateVisibility();
  },

  //destroy all variables when the the visualisation is not shown anymore
  destroyed() {
    this.selection = null;
    this.simulation.stop();
    this.simulation = null;
    this.vEdges = null;
    this.transform = null;
    this.color = null;
    this.nodeLinkedEdges = null;
    this.maxDegree = null;
    this.circleRadius = null;
    this.immutableNodeLinkedEdges = null;
  }
};
</script>
